<?php

/*************************************************************
*  TorrentFlux - PHP Torrent Manager
*  www.torrentflux.com
**************************************************************/
/*
    This file is part of TorrentFlux.

    TorrentFlux is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentFlux is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentFlux; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


include_once("config.php");
include_once("functions.php");

class dir {

  var $name;
  var $subdirs;
  var $files;
  var $num;
  var $prio;
  
  function dir($name,$num,$prio) {
    $this->name = $name;
    $this->num = $num;
    $this->prio = $prio;    
    $this->files = array();
    $this->subdirs = array();
  }
  
  function &addFile($file) {
    $this->files[] =& $file;
    return $file;
  }

  function &addDir($dir) {
    $this->subdirs[] =& $dir;
    return $dir;
  }
  
  function &findDir($name) {
      foreach( $this->subdirs as $v )
        if($v->name == $name)
          return $v;
      
      return false;
  }
  
  function draw($parent) {
  
  echo('d.add('.$this->num.','.$parent.',"'.$this->name."\",".$this->prio.",0);\n");

  foreach($this->subdirs as $v) {
      $v->draw($this->num);
  }

  foreach($this->files as $v)
      if(is_object($v)) {
        echo("d.add(".$v->num.",".$this->num.",\"".$v->name."\",".$v->prio.",".$v->size.");\n");
      }
  }
}

class file {
  
  var $name;
  var $prio;
  var $size;
  var $num;

  function file($name,$num,$size,$prio) {
    $this->name = $name;
    $this->num = $num;
    $this->size = $size;    
    $this->prio = $prio;
    
  }
  
}

DisplayHead(_TORRENTDETAILS,true,"","",true);
?>
<div align="left" id="BodyLayer" name="BodyLayer" style="border: thin solid <?php echo $cfg["main_bgcolor"] ?>; position:relative; width:100%; height:500; padding-left: 5px; padding-right: 5px; z-index:1; overflow: scroll; visibility: visible">

<?php

if(isset($torrent))
{
require_once('BDecode.php');
    $ftorrent=$cfg["torrent_file_path"].$torrent;
    $fd = fopen($ftorrent, "rd");
    $alltorrent = fread($fd, filesize($ftorrent));
    $btmeta = BDecode($alltorrent);

    if ( is_readable($cfg["torrent_file_path"].getAliasName($torrent).".prio")) {
      $prio = file_get_contents($cfg["torrent_file_path"].getAliasName($torrent).".prio");
      $prio = array_splice(split(',',$prio),1);
    } else {
      $prio = array();
      for($i=0;$i<count($btmeta['info']['files']);$i++)
         $prio[$i] = -1;
    }

    echo "<form action=\"setpriority.php?torrent=".$torrent."\" method=\"POST\">";

    echo "<table><tr>";
    echo "<tr><td>Torrent file:</td><td>".$btmeta['info']['name']."</td></tr>";
    echo "<tr><td>Tracker URL:</td><td>".$btmeta['announce']."</td></tr>";
    echo "<tr><td>Created:</td><td>".$btmeta['creation date']."</td></tr>";
    $torrent_size = $btmeta["info"]["piece length"] * (strlen($btmeta["info"]["pieces"]) / 20);
    echo "<tr><td>All files size:</td><td>".$torrent_size." (".formatBytesToKBMGGB($torrent_size).")</td></tr>";
    echo "<tr><td>Chunk size:</td><td>".$btmeta['info']['piece length']." (".formatBytesToKBMGGB($btmeta['info']['piece length']).")</td></tr>";
    echo "<tr><td>Selected size:</td><td id=\"sel\">0</td></tr></table><br>";


    $dirnum = count($btmeta['info']['files']);
    $tree = new dir("/",$dirnum,isset($prio[$dirnum])?$prio[$dirnum]:-1);
	

    foreach( $btmeta['info']['files'] as $filenum => $file) {
     	$dir_name = $file['path'][0];
		if($dir_name != $old_dir_name){
		$branch =& $tree;
		}
    	$depth = count($file['path']);
    	for($i=0; $i < $depth; $i++)
		{
			if ($i != $depth-1)
	  		{
        		$d =& $branch->findDir($file['path'][$i]);
          
        		if($d){
            		$branch =& $d;
          		}else{
            		$dirnum++;
				
					if($dir_name != $old_dir_name){
	  					$d =& $branch->addDir(new dir($file['path'][$i], $dirnum, (isset($prio[$dirnum])?$prio[$dirnum]:-1)));
            			$branch =& $d;
					}
					$old_dir_name = $file['path'][$i];
         		}
        	}else{
				$branch->addFile(new file($file['path'][$i]." (".$file['length'].")",$filenum,$file['length'],$prio[$filenum]));
			}
      }
}

	

    echo "<script type=\"text/javascript\"> d = new dTree('d');";
    $tree->draw(-1);
    echo 'document.write(d);sel = getSizes(); drawSel()</script>';
    echo "<input type=\"hidden\" name=\"filecount\" value=\"".count($btmeta['info']['files'])."\">";    
    echo "<input type=\"hidden\" name=\"count\" value=\"".$dirnum."\">";
    echo '<input type="submit" value="Save"></form>';
}
else
{
 	$result = _NORECORDSFOUND;
}
DisplayFoot();

?>