<?php

/*************************************************************
*  TorrentFlux - PHP Torrent Manager
*  www.torrentflux.com
**************************************************************/
/*
    This file is part of TorrentFlux.

    TorrentFlux is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentFlux is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentFlux; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include_once("config.php");
include_once("functions.php");

//****************************************************************************
// showIndex -- main view
function showIndex()
{
	global $cfg, $db;

	$hideChecked = "";

	if ($cfg["hide_offline"] == 1)
	{
		$hideChecked = "checked";
	}

	DisplayHead($cfg["user"]."'s "._PROFILE);

	echo "<div align=\"center\">";
	echo "<table border=1 bordercolor=\"".$cfg["table_admin_border"]."\" cellpadding=\"2\" cellspacing=\"0\" width=\"95%\">";
	echo "<tr><td colspan=6 bgcolor=\"".$cfg["table_data_bg"]."\" background=\"themes/".$cfg["theme"]."/images/bar.gif\">";
	echo "<img src=\"images/properties.png\" width=18 height=13 border=0>&nbsp;&nbsp;<font class=\"title\">".$cfg["user"]."'s "._PROFILE."</font>";
	echo "</td></tr><tr><td align=\"center\">";

	$total_activity = GetActivityCount();

	$sql= "SELECT user_id, hits, last_visit, time_created, user_level FROM tf_users WHERE user_id=".$db->qstr($cfg["user"]);
	list($user_id, $hits, $last_visit, $time_created, $user_level) = $db->GetRow($sql);

	$user_type = _NORMALUSER;
	if (IsAdmin())
	{
		$user_type = _ADMINISTRATOR;
	}
	if (IsSuperAdmin())
	{
		$user_type = _SUPERADMIN;
	}


	$user_activity = GetActivityCount($cfg["user"]);

	if ($user_activity == 0)
	{
		$user_percent = 0;
	}
	else
	{
		$user_percent = number_format(($user_activity/$total_activity)*100);
	}

?>

	<table width="100%" border="0" cellpadding="3" cellspacing="0">
	<tr>
		<td width="50%" bgcolor="<?php echo $cfg["table_data_bg"] ?>" valign="top">

		<div align="center">
		<table border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td align="right"><?php echo _JOINED ?>:&nbsp;</td>
			<td><strong><?php echo date(_DATETIMEFORMAT, $time_created) ?></strong></td>
		</tr>
		<tr>
			<td colspan="2" align="center">&nbsp;</td>
		</tr>
		<tr>
			<td align="right"><?php echo _UPLOADPARTICIPATION ?>:&nbsp;</td>
			<td>
				<table width="200" border="0" cellpadding="0" cellspacing="0">
				<tr>
					<td background="themes/<?php echo $cfg["theme"] ?>/images/proglass.gif" width="<?php echo $user_percent*2 ?>"><img src="images/blank.gif" width="1" height="12" border="0"></td>
					<td background="themes/<?php echo $cfg["theme"] ?>/images/noglass.gif" width="<?php echo (200 - ($user_percent*2)) ?>"><img src="images/blank.gif" width="1" height="12" border="0"></td>
				</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td align="right"><?php echo _UPLOADS ?>:&nbsp;</td>
			<td><strong><?php echo $user_activity ?></strong></td>
		</tr>
		<tr>
			<td align="right"><?php echo _PERCENTPARTICIPATION ?>:&nbsp;</td>
			<td><strong><?php echo $user_percent ?>%</strong></td>
		</tr>
		<tr>
			<td colspan="2" align="center"><div align="center" class="tiny">(<?php echo _PARTICIPATIONSTATEMENT. " ".$cfg['days_to_keep']." "._DAYS ?>)</div><br></td>
		</tr>
		<tr>
			<td align="right"><?php echo _TOTALPAGEVIEWS ?>:&nbsp;</td>
			<td><strong><?php echo $hits ?></strong></td>
		</tr>
		<tr>        
			<td colspan="2" align="center"><br />[<a href="profile.php?op=showCookies">Cookies</a>]<p></td>
    </tr>
		<tr>
			<td align="right"><?php echo _USERTYPE ?>:&nbsp;</td>
			<td><strong><?php echo $user_type ?></strong></td>
		</tr>
		</table>
		</div>

		</td>
		<td valign="top">
		<div align="center">
		<table cellpadding="5" cellspacing="0" border="0">
		<form name="theForm" action="profile.php?op=updateProfile" method="post" onsubmit="return validateProfile()">
		<tr>
			<td align="right"><?php echo _USER ?>:</td>
			<td>
			<input readonly="true" type="Text" value="<?php echo $cfg["user"] ?>" size="15">
			</td>
		</tr>
		<tr>
			<td align="right"><?php echo _NEWPASSWORD ?>:</td>
			<td>
			<input name="pass1" type="Password" value="" size="15">
			</td>
		</tr>
		<tr>
			<td align="right"><?php echo _CONFIRMPASSWORD ?>:</td>
			<td>
			<input name="pass2" type="Password" value="" size="15">
			</td>
		</tr>
		<tr>
			<td align="right"><?php echo _THEME ?>:</td>
			<td>
			<select name="theme">
<?php
	$arThemes = GetThemes();
	for($inx = 0; $inx < sizeof($arThemes); $inx++)
	{
		$selected = "";
		if ($cfg["theme"] == $arThemes[$inx])
		{
			$selected = "selected";
		}
		echo "<option value=\"".$arThemes[$inx]."\" ".$selected.">".$arThemes[$inx]."</option>";
	}
?>
			</select>
			</td>
		</tr>
				<tr>
			<td align="right"><?php echo _LANGUAGE ?>:</td>
			<td>
			<select name="language">
<?php
	$arLanguage = GetLanguages();
	for($inx = 0; $inx < sizeof($arLanguage); $inx++)
	{
		$selected = "";
		if ($cfg["language_file"] == $arLanguage[$inx])
		{
			$selected = "selected";
		}
		echo "<option value=\"".$arLanguage[$inx]."\" ".$selected.">".GetLanguageFromFile($arLanguage[$inx])."</option>";
	}
?>
			</select>
			</td>
		</tr>
		<tr>
			<td colspan="2">
			<input name="hideOffline" type="Checkbox" value="1" <?php echo $hideChecked ?>> <?php echo _HIDEOFFLINEUSERS ?><br>
			</td>
		</tr>
		<tr>
			<td align="center" colspan="2">
			<input type="Submit" value="<?php echo _UPDATE ?>">
			</td>
		</tr>
		</form>
		</table>
		</div>
		</td>
	</tr>
	</table>


	<script language="JavaScript">
	function validateProfile()
	{
		var msg = ""
		if (theForm.pass1.value != "" || theForm.pass2.value != "")
		{
			if (theForm.pass1.value.length <= 5 || theForm.pass2.value.length <= 5)
			{
				msg = msg + "* <?php echo _PASSWORDLENGTH ?>\n";
				theForm.pass1.focus();
			}
			if (theForm.pass1.value != theForm.pass2.value)
			{
				msg = msg + "* <?php echo _PASSWORDNOTMATCH ?>\n";
				theForm.pass1.value = "";
				theForm.pass2.value = "";
				theForm.pass1.focus();
			}
		}

		if (msg != "")
		{
			alert("<?php echo _PLEASECHECKFOLLOWING ?>:\n\n" + msg);
			return false;
		}
		else
		{
			return true;
		}
	}
	</script>

<?php
	echo "</td></tr>";
	echo "</table></div><br><br>";

	DisplayFoot();
}

//****************************************************************************
 // showCookies -- show Cookies,
 function showCookies ()
 {
       global $cfg;
         $feeds = array();
         $param = array();

       DisplayHead($cfg["user"]."'s "._PROFILE);

       echo "<div align=\"center\">";
       echo "<table border=1 bordercolor=\"".$cfg["table_admin_border"]."\" cellpadding=\"2\" cellspacing=\"0\" width=\"760\">";
       echo "<tr><td colspan=6 bgcolor=\"".$cfg["table_data_bg"]."\" background=\"themes/".$cfg["theme"]."/images/bar.gif\">";
       echo "<img src=\"images/properties.png\" width=18 height=13 border=0>&nbsp;&nbsp;<font class=\"title\">".$cfg["user"]."'s "._COOKIES."</font>";
       echo "</td></tr><tr><td align=\"center\">";

       $sql= "SELECT host, data  FROM tf_cookies WHERE userid='".$cfg["user"]."'";
       $result = mysql_query($sql);

         if (mysql_num_rows($result) > 0)
         {
           while ($row = mysql_fetch_assoc($result))
           {
             $param[] = array('host' => $row['host'], 'data' => $row['data']);
           }
         }
         mysql_free_result ($result);

         unset($sql);


 ?>

       <table width="100%" border="0" cellpadding="3" cellspacing="0">
       <tr>
           <td width="100%" bgcolor="<?php echo $cfg["table_data_bg"] ?>" valign="top">
             <div align="center">
             <table border="0" cellpadding="0" cellspacing="0">
                 <form name="theForm" action="profile.php?op=addCookie" method="post">
               <tr>
                   <td width="80" align="right">&nbsp;Host:</td>
                 	 <td>
											<input name="host" type="text"><BR />
			             </td>
      			       <td>
            			    www.host.com
            			 </td>
 				        </tr>
        				<tr>
            				<td width="80" align="right">&nbsp;Data:</td>
            				<td>
               					<input name="data" type="text"><BR />
            				</td>
            				<td>
                				uid=123456;pass=a1b2c3d4e5f6g7h8i9j1
            				</td>
        				</tr>
        				<tr>
            				<td>&nbsp;</td>
            				<td colspan="2">
                				<input type="submit" value="Ok"><BR />
            				</td>
                 </tr></form>
               </table>
             </div>
           </td>
         </tr>
         <tr>
           <td width="100%" bgcolor="<?php echo $cfg["table_data_bg"] ?>" valign="top">
             <div align="center">
               <table border="1" cellpadding="1" cellspacing="1" width="100%" align="center">
                 <tr>
                   <td align="center">
                     <?php
                     foreach ($param as $rid)
                     {
                       echo "<tr>\n";
                       echo "<td align='left'>".$rid['host']."</td>\n";
                       echo "<td align='right'>".$rid['data']."</td>\n";
                       echo "<td align='right'><a href='profile.php?op=delCookie&rid=".$rid['host']."'>DELETE</a></td>\n";
                       echo "</tr>";
                     }
                     ?>
                   </td>
                 </tr>
               </table>
             </div>
           </td>
         </tr>
       </table>

 <?php
       echo "</td></tr>";
       echo "</table></div><br><br>";

       DisplayFoot();
 }


                                                         //****************************************************************************
 // delCookie -- delete cookie identified by $rid
 function delCookie ($rid)
 {
   global $cfg, $db;
   //settype($rid, 'integer');
   $sql = "DELETE FROM tf_cookies WHERE userid = '" . $cfg['user'] . "' AND host = " . $db->qstr($rid);
   $db->execute($sql);

   DisplayHead($cfg["user"]."'s Profile");

   echo "<div align=\"center\">";
   echo "<table border=1 bordercolor=\"".$cfg["table_admin_border"]."\" cellpadding=\"2\" cellspacing=\"0\" bgcolor=\"".$cfg["table_data_bg"]."\" width=\"760\">";
   echo "<tr><td colspan=6 background=\"themes/".$cfg["theme"]."/images/bar.gif\">";
   echo "<img src=\"images/properties.png\" width=18 height=13 border=0>&nbsp;&nbsp;<font class=\"title\">".$cfg["user"]."'s Cookies</font>";
   echo "</td></tr><tr><td align=\"center\">";
 ?>
   <br>
   <?php echo "Deleted cookie: ".$rid ?>
   <br><br><?php
   echo "</td></tr>";
   echo "</table></div><br><br>";

   DisplayFoot();
 }

 function addCookie ($rid, $param)
 {
   global $cfg;
   $sql = "INSERT INTO tf_cookies (userid, host, data) VALUES ('" .$cfg['user']. "', '". $rid ."', '". mysql_real_escape_string($param) ."')";
   $result = mysql_query($sql);
   echo mysql_error();
   unset($sql);
   DisplayHead($cfg["user"]."'s "._PROFILE);

   echo "<div align=\"center\">";
   echo "<table border=1 bordercolor=\"".$cfg["table_admin_border"]."\" cellpadding=\"2\" cellspacing=\"0\" bgcolor=\"".$cfg["table_data_bg"]."\" width=\"760\">";
   echo "<tr><td colspan=6 background=\"themes/".$cfg["theme"]."/images/bar.gif\">";
   echo "<img src=\"images/properties.png\" width=18 height=13 border=0>&nbsp;&nbsp;<font class=\"title\">".$cfg["user"]."'s Cookies</font>";
   echo "</td></tr><tr><td align=\"center\">";
 ?>
   <br>
   <?php echo "Cookie added for: ".$rid ?>
   <br><br>
   <?php
   echo "</td></tr>";
   echo "</table></div><br><br>";

   DisplayFoot();
 }


//****************************************************************************
// updateProfile -- update profile
function updateProfile($pass1, $pass2, $hideOffline, $theme, $language)
{
	Global $cfg;

	if ($pass1 != "")
	{
		$_SESSION['user'] = md5($cfg["pagetitle"]);
	}

	UpdateUserProfile($cfg["user"], $pass1, $hideOffline, $theme, $language);

	DisplayHead($cfg["user"]."'s "._PROFILE);

	echo "<div align=\"center\">";
	echo "<table border=1 bordercolor=\"".$cfg["table_admin_border"]."\" cellpadding=\"2\" cellspacing=\"0\" bgcolor=\"".$cfg["table_data_bg"]."\" width=\"95%\">";
	echo "<tr><td colspan=6 background=\"themes/".$cfg["theme"]."/images/bar.gif\">";
	echo "<img src=\"images/properties.png\" width=18 height=13 border=0>&nbsp;&nbsp;<font class=\"title\">".$cfg["user"]."'s "._PROFILE."</font>";
	echo "</td></tr><tr><td align=\"center\">";
?>
	<br>
	<?php echo _PROFILEUPDATEDFOR." ".$cfg["user"] ?>
	<br><br>
<?php
	echo "</td></tr>";
	echo "</table></div><br><br>";

	DisplayFoot();
}



//****************************************************************************
//****************************************************************************
//****************************************************************************
//****************************************************************************
// TRAFFIC CONTROLER
switch ($op)
{

    default:
    	showIndex();
    break;

    case "updateProfile":
    	updateProfile($pass1, $pass2, $hideOffline, $theme, $language);
    break;
    
    case "addCookie":
            addCookie($_POST['host'], $_POST['data']);
    break;

    case "showCookies":
            showCookies();
    break;

    case "delCookie":
            delCookie($rid);
    break;
}
//****************************************************************************
//****************************************************************************
//****************************************************************************
//****************************************************************************

?>